/**
 */
package org.eclipse.gef4.dot.internal.parser.splinetype;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.gef4.dot.internal.parser.splinetype.SplinetypeFactory
 * @model kind="package"
 * @generated
 */
public interface SplinetypePackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "splinetype";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.eclipse.org/gef4/dot/internal/parser/DotSplineType";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "splinetype";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  SplinetypePackage eINSTANCE = org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl.init();

  /**
   * The meta object id for the '{@link org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineTypeImpl <em>Spline Type</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineTypeImpl
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl#getSplineType()
   * @generated
   */
  int SPLINE_TYPE = 0;

  /**
   * The feature id for the '<em><b>Splines</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SPLINE_TYPE__SPLINES = 0;

  /**
   * The number of structural features of the '<em>Spline Type</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SPLINE_TYPE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineImpl <em>Spline</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineImpl
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl#getSpline()
   * @generated
   */
  int SPLINE = 1;

  /**
   * The feature id for the '<em><b>Endp</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SPLINE__ENDP = 0;

  /**
   * The feature id for the '<em><b>Startp</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SPLINE__STARTP = 1;

  /**
   * The feature id for the '<em><b>Control Points</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SPLINE__CONTROL_POINTS = 2;

  /**
   * The number of structural features of the '<em>Spline</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SPLINE_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link org.eclipse.gef4.dot.internal.parser.splinetype.impl.PointImpl <em>Point</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.PointImpl
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl#getPoint()
   * @generated
   */
  int POINT = 2;

  /**
   * The feature id for the '<em><b>X</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POINT__X = 0;

  /**
   * The feature id for the '<em><b>Y</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POINT__Y = 1;

  /**
   * The feature id for the '<em><b>Z</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POINT__Z = 2;

  /**
   * The feature id for the '<em><b>Input Only</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POINT__INPUT_ONLY = 3;

  /**
   * The number of structural features of the '<em>Point</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POINT_FEATURE_COUNT = 4;


  /**
   * Returns the meta object for class '{@link org.eclipse.gef4.dot.internal.parser.splinetype.SplineType <em>Spline Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Spline Type</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.SplineType
   * @generated
   */
  EClass getSplineType();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.gef4.dot.internal.parser.splinetype.SplineType#getSplines <em>Splines</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Splines</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.SplineType#getSplines()
   * @see #getSplineType()
   * @generated
   */
  EReference getSplineType_Splines();

  /**
   * Returns the meta object for class '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Spline <em>Spline</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Spline</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Spline
   * @generated
   */
  EClass getSpline();

  /**
   * Returns the meta object for the containment reference '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Spline#getEndp <em>Endp</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Endp</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Spline#getEndp()
   * @see #getSpline()
   * @generated
   */
  EReference getSpline_Endp();

  /**
   * Returns the meta object for the containment reference '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Spline#getStartp <em>Startp</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Startp</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Spline#getStartp()
   * @see #getSpline()
   * @generated
   */
  EReference getSpline_Startp();

  /**
   * Returns the meta object for the containment reference list '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Spline#getControlPoints <em>Control Points</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Control Points</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Spline#getControlPoints()
   * @see #getSpline()
   * @generated
   */
  EReference getSpline_ControlPoints();

  /**
   * Returns the meta object for class '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Point <em>Point</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Point</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Point
   * @generated
   */
  EClass getPoint();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Point#getX <em>X</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>X</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Point#getX()
   * @see #getPoint()
   * @generated
   */
  EAttribute getPoint_X();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Point#getY <em>Y</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Y</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Point#getY()
   * @see #getPoint()
   * @generated
   */
  EAttribute getPoint_Y();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Point#getZ <em>Z</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Z</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Point#getZ()
   * @see #getPoint()
   * @generated
   */
  EAttribute getPoint_Z();

  /**
   * Returns the meta object for the attribute '{@link org.eclipse.gef4.dot.internal.parser.splinetype.Point#isInputOnly <em>Input Only</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Input Only</em>'.
   * @see org.eclipse.gef4.dot.internal.parser.splinetype.Point#isInputOnly()
   * @see #getPoint()
   * @generated
   */
  EAttribute getPoint_InputOnly();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  SplinetypeFactory getSplinetypeFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineTypeImpl <em>Spline Type</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineTypeImpl
     * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl#getSplineType()
     * @generated
     */
    EClass SPLINE_TYPE = eINSTANCE.getSplineType();

    /**
     * The meta object literal for the '<em><b>Splines</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SPLINE_TYPE__SPLINES = eINSTANCE.getSplineType_Splines();

    /**
     * The meta object literal for the '{@link org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineImpl <em>Spline</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplineImpl
     * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl#getSpline()
     * @generated
     */
    EClass SPLINE = eINSTANCE.getSpline();

    /**
     * The meta object literal for the '<em><b>Endp</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SPLINE__ENDP = eINSTANCE.getSpline_Endp();

    /**
     * The meta object literal for the '<em><b>Startp</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SPLINE__STARTP = eINSTANCE.getSpline_Startp();

    /**
     * The meta object literal for the '<em><b>Control Points</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference SPLINE__CONTROL_POINTS = eINSTANCE.getSpline_ControlPoints();

    /**
     * The meta object literal for the '{@link org.eclipse.gef4.dot.internal.parser.splinetype.impl.PointImpl <em>Point</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.PointImpl
     * @see org.eclipse.gef4.dot.internal.parser.splinetype.impl.SplinetypePackageImpl#getPoint()
     * @generated
     */
    EClass POINT = eINSTANCE.getPoint();

    /**
     * The meta object literal for the '<em><b>X</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute POINT__X = eINSTANCE.getPoint_X();

    /**
     * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute POINT__Y = eINSTANCE.getPoint_Y();

    /**
     * The meta object literal for the '<em><b>Z</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute POINT__Z = eINSTANCE.getPoint_Z();

    /**
     * The meta object literal for the '<em><b>Input Only</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute POINT__INPUT_ONLY = eINSTANCE.getPoint_InputOnly();

  }

} //SplinetypePackage
